Index: protocol.lisp
===================================================================
RCS file: /project/cl-irc/cvsroot/cl-irc/protocol.lisp,v
retrieving revision 1.24
diff -u -r1.24 protocol.lisp
--- protocol.lisp	17 Apr 2005 21:14:30 -0000	1.24
+++ protocol.lisp	24 Sep 2005 18:54:17 -0000
@@ -772,12 +772,21 @@
 
 (defmethod find-or-make-user ((connection connection) nickname &key (username "")
                               (hostname "") (realname ""))
-  (or (find-user connection nickname)
-      (make-user connection
-                 :nickname nickname
-                 :username username
-                 :hostname hostname
-                 :realname realname)))
+  (let ((user (find-user connection nickname)))
+    (unless user
+      (setf user
+            (make-user connection
+                       :nickname nickname
+                       :username username
+                       :hostname hostname
+                       :realname realname)))
+    (labels ((update-slot-if-known (slotname value)
+               (when (string= (slot-value user slotname) "")
+                 (setf (slot-value user slotname) value))))
+      (update-slot-if-known 'username username)
+      (update-slot-if-known 'hostname hostname)
+      (update-slot-if-known 'realname realname))
+    user))
 
 (defmethod change-nickname ((connection connection) (user user) new-nickname)
   (let ((new-user user)
